



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>.NET 实现并行的几种方式（四）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">.NET 实现并行的几种方式（四）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-18 04:48:34 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>本随笔续接：<a href="http://www.cnblogs.com/08shiyan/p/6092688.html" rel="external nofollow noreferrer">.NET 实现并行的几种方式（三）</a></p>
<h2>八、await、async - 异步方法的秘密武器</h2>
<h3>1） 使用async修饰符 和 await运算符 轻易实现异步方法</h3>
<p>前三篇随笔已经介绍了多种方式、利用多线程、充分利用多核心CPU以提高运行效率。但是以前的方式在WebAPI和GUI系统上、</p>
<p>使用起来还是有些繁琐，尤其是在需要上下文的情况下。而await/async就是在这样的情况下应运而生，并且它可以在理论上让CPU跑到100%。</p>
<p>async修饰符：它用以修饰方法、lambda表达式、匿名方法，以标记方法为异步方法。异步方法必须遵循的规范如下：</p>
<p>1、返回值仅且仅有三种： void、Task、Task&lt;T&gt;.</p>
<p>2、方法参数不可以使用 ref、out类型参数。</p>
<p>await运算符：它用以标记一个系统可在其上恢复执行的挂起点。该运算符会告诉computer不会再往下继续执行该方法、直到等待的异步方法执行完毕为止。同时会将程序的控制权return给其调用者。await表达式不阻止正在执行它的线程。 而是让编译器将异步方法剩余部分注册为等待任务的延续任务。 当等待任务完成时，它会调用其延续任务，如同在挂起点上恢复执行。</p>
<h3>2）简单Demo</h3>
<div>
<div>
<pre class="prettyprint linenums">// Three things to note in the signature:<br />
//  - The method has an async modifier.<br />
//  - The return type is Task or Task&lt;T&gt;. (See "Return Types" section.)<br />
//    Here, it is Task&lt;int&gt; because the return statement returns an integer.<br />
//  - The method name ends in "Async."<br />
async Task&lt;int&gt; AccessTheWebAsync()<br />
{<br />
    // You need to add a reference to System.Net.Http to declare client.<br />
    HttpClient client = new HttpClient();  

    // GetStringAsync returns a Task&lt;string&gt;. That means that when you await the<br />
    // task you'll get a string (urlContents).<br />
    Task&lt;string&gt; getStringTask = client.GetStringAsync("http://msdn.microsoft.com");  

    // You can do work here that doesn't rely on the string from GetStringAsync.<br />
    DoIndependentWork();  

    // The await operator suspends AccessTheWebAsync.<br />
    //  - AccessTheWebAsync can't continue until getStringTask is complete.<br />
    //  - Meanwhile, control returns to the caller of AccessTheWebAsync.<br />
    //  - Control resumes here when getStringTask is complete.<br />
    //  - The await operator then retrieves the string result from getStringTask.<br />
    string urlContents = await getStringTask;  

    // The return statement specifies an integer result.<br />
    // Any methods that are awaiting AccessTheWebAsync retrieve the length value.<br />
    return urlContents.Length;<br />
}  </pre>
</div>
<p>await/async demo</p></div>
<h3>3）直观的顺序图</h3>
<p>该图出自： <a href="https://msdn.microsoft.com/zh-cn/library/mt674882.aspx" rel="external nofollow noreferrer">https://msdn.microsoft.com/zh-cn/library/mt674882.aspx</a></p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/86939/201611/86939-20161124172313143-1772446752.jpg" /></p>
<h3>4) await async编程最佳做法</h3>
<h4>1、异步方法尽量少用 void类型返回值、替代方案 使用Task类型，特例：异步事件处理函数使用void类型</h4>
<p>原因1、async void 无法使用try ... catch进行异常捕获，它的异常会在上下文中引发。捕获该种异常的方式为在GUI或web系统中使用</p>
<p>AppDomain.UnhandledException 进行全局异常捕获。对于需要进队异常进行处理的地方、这将是个灾难。</p>
<p>原因2、async void 方法、不可以&ldquo;方便&rdquo;的知道其什么时候完成，这对于超过50%的异步方法而言、将是灭顶之灾。而 async Task</p>
<p>可以配合 await、await&nbsp;Task.WhenAny、await Task.WhenAll、await&nbsp;Task.Delay、await Task.Yield 方便的进行后续的任务处理工作。</p>
<p>特例、因为事件本身是不需要返回值的，并且事件的异常也会在上下文中引发、这是合理的。所以异步的事件处理函数使用void类型。</p>
<h4>2、推荐一直使用async，而不要混合使用阻塞和异步（async）避免死锁， 特例：Main方法</h4>
<p>使用混合编程的死锁demo</p>
<div>
<div>
<pre class="prettyprint linenums">public static class DeadlockDemo<br />
{<br />
  private static async Task DelayAsync()<br />
  {<br />
    await Task.Delay();<br />
  }<br />
  // This method causes a deadlock when called in a GUI or ASP.NET context.<br />
public static void Test()<br />
  {<br />
    // Start the delay.<br />
var delayTask = DelayAsync();<br />
    // Wait for the delay to complete.<br />
delayTask.Wait();<br />
  }<br />
}</pre>
</div>
<p>DeadlockDemo</p></div>
<p>当在GUI或者web上执行（具有上下文的环境中），会导致死锁。这种死锁的根本原因是 await 处理上下文的方式。&nbsp;默认情况下，当等待未完成的 Task 时，会捕获当前&ldquo;上下文&rdquo;，在 Task 完成时使用该上下文恢复方法的执行。&nbsp;此&ldquo;上下文&rdquo;是当前 SynchronizationContext（除非它是 null，这种情况下则为当前 TaskScheduler）。&nbsp;GUI 和 ASP.NET 应用程序具有 SynchronizationContext，它每次仅允许一个代码区块运行。&nbsp;当 await 完成时，它会尝试在捕获的上下文中执行 async 方法的剩余部分。&nbsp;但是该上下文已含有一个线程，该线程在（同步）等待 async 方法完成。&nbsp;它们相互等待对方，从而导致死锁。</p>
<p>特例：Main方法是不可用async修饰符进行修饰的（编译不通过）。</p>
<table>
<tbody>
<tr>
<td>执行以下操作&hellip;</td>
<td>阻塞式操作&hellip;</td>
<td>async的替换操作</td>
</tr>
<tr>
<td>检索后台任务的结果</td>
<td>Task.Wait 或 Task.Result</td>
<td>await</td>
</tr>
<tr>
<td>等待任何任务完成</td>
<td>Task.WaitAny</td>
<td>await Task.WhenAny</td>
</tr>
<tr>
<td>检索多个任务的结果</td>
<td>Task.WaitAll</td>
<td>await Task.WhenAll</td>
</tr>
<tr>
<td>等待一段时间</td>
<td>Thread.Sleep</td>
<td>await Task.Delay</td>
</tr>
</tbody>
</table>
<h4>3、如果可以，请用ConfigureAwait&nbsp;忽略上下文</h4>
<p>上文也说过了，当异步任务完成后、它会尝试在之前的上下文环境中恢复执行。这样带来的问题是时间片会被切分成更多、造成更多的线程调度上的性能损耗。</p>
<p>一旦时间片被切分的过多、尤其是在GUI和Web具有上下文环境中运行，影响会更大。</p>
<p>另外，使用ConfigureAwait忽略上下文后、可避免死锁。 因为当等待完成时，它会尝试在线程池上下文中执行 async 方法的剩余部分，不会存在线程等待。</p>
<h3>5）疑问：关于 await的使用次数 和 使用的线程数量 之间的关系</h3>
<p>使用一个await运算符，就一定会使用一个新的线程吗？ 答案：不是的。</p>
<p>前文已经介绍过，await运算符是依赖Task完成异步的、并且将后续代码至于Task的延续任务之中（这一点是编译器搞得怪、生成了大量的模板代码来实现该功能）。</p>
<p>因此，编译器以await为分割点，将前一部分的等待任务和后一部分的延续任务分割到两个线程之中。</p>
<p>前一部分的等待任务：该部分是Task依赖调度器（TaskScheduler）、从线程池中分配的工作线程。</p>
<p>而后一部分的延续任务：该部分所运行的线程取决于两点：第一点，Task等待任务在运行之前捕获的上下文环境，第二点：是否使用ConfigureAwait (false)</p>
<p>忽略了之前捕获的上下文。如果没有忽略上下文并且之前捕获的上下文环境为：SynchronizationContext（即 GUI UI线程 或 Web中具有HttpContext的线程环境）</p>
<p>则 延续任务继续在&nbsp;SynchronizationContext 上下文环境中运行，否则 将使用调度器（TaskScheduler）从线程池中获取线程来运行。</p>
<p>另外注意：调度器从线程池中获取的线程、并不一定是新的，即使在循环连续使用多次（如果任务很快完成），那么也有可能多次都使用同一个线程。</p>
<p>测试demo:</p>
<div>
<div>
<pre class="prettyprint linenums">        /// &lt;summary&gt;<br />
        /// 在循环中使用await, 观察使用的线程数量<br />
        /// &lt;/summary&gt;<br />
        /// &lt;returns&gt;&lt;/returns&gt;<br />
        public async Task ForMethodAsync()<br />
        {<br />
            // 休眠<br />
            // await Task.Delay(TimeSpan.FromMilliseconds(100)).ConfigureAwait(false);<br />
            // await Task.Delay(TimeSpan.FromMilliseconds(100));

            for (int i = ; i &lt; ; i++)<br />
            {<br />
                await Task.Run(() =&gt;<br />
                {<br />
                    // 打印线程id<br />
                    PrintThreadInfo("ForMethodAsync", i.ToString());<br />
                });<br />
            }<br />
        }</pre>
</div>
<p>在循环中使用await, 观察使用的线程数量</p></div>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/86939/201612/86939-20161201101041209-919833348.jpg" /></p>
<p>上述demo在运行多次后，可能会得到上述结果：5次循环使用的是同一个线程，线程id为16，UI线程id为10。</p>
<p>结论：<strong>await的使用次数 大于 使用的线程数量，也有可能、多次使用await 只会 使用一个线程。</strong></p>
<h3>6）await/async 的缺点</h3>
<p>1、由于编译在搞怪、会生成大量的模板代码、使得单个异步方法 比 单个同步方法 运行得要慢，与之相对应的获取到的性能优势是、充分利用了多核心CPU，提高了任务并发量。</p>
<p>2、掩盖了线程调度、使得系统开发人员无意识的忽略了该方面的性能损耗。</p>
<p>3、如果使用不当，容易造成死锁</p>
<p>附，Demo :&nbsp;<a href="http://files.cnblogs.com/files/08shiyan/ParallelDemo.zip" rel="external nofollow noreferrer">http://files.cnblogs.com/files/08shiyan/ParallelDemo.zip</a></p>
<p>参见更多：<a href="http://www.cnblogs.com/08shiyan/p/5692317.html" rel="external nofollow noreferrer">随笔导读：同步与异步</a></p>
<p>(未完待续...)</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/jqdzjj09.html">内存管理 - MEMORY POOL</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq45e1j9.html">DataGridView 中添加CheckBox和常用处理方式 &period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rvydd8.html">csharp&colon;Compare two DataTables to rows in one but not the other</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdgd1e8.html">poj 3264 Balanced Lineup （线段树）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1y07g8.html">欧拉工程第66题：Diophantine equation</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdzdoy8.html">HDU 5071 Chat&lpar;2014鞍山B，模拟&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z2pm09.html">XML PUBLISHER输出excel禁止自动将数字格式化处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0g27gq.html">C&num; 根据Word模版生成Word文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0ozylq.html">laravel框架&mdash;&mdash;路由</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdenry79.html">iOS 无效的版本，提交成功，不出现版本号</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zlleg9.html">objective-c学习笔记2</a>
		</li>
						<li><a href="https://www.batexi.com/a/9geg23l8.html">&lbrack;Python&rsqb; wxPython 菜单栏控件学习总结（原创）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jeyvv8.html">【微软大法好】VS Tools for AI全攻略（2）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkggdj8.html">分布式内存文件系统Tachyon</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk70oj8.html">FFmpeg 结构体学习&lpar;一&rpar;： AVFormatContext 分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/9506kn08.html">conda安装cv2库</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2mvppq.html">python note 4</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4vekeq.html">MAC OS 英语朗读功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/953j3we8.html">BZOJ1299 &lbrack;LLH邀请赛&rsqb;巧克力棒</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7en2gg9.html">NBUT 1222 English Game 2010辽宁省赛</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/r8mjp08k.html">C&plus;&plus;随笔：&period;NET CoreCLR之corleCLR核心探索之coreconsole（2）</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gp5z97.html">pdo的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8ovmxqz.html">编译器开发系列--Ocelot语言4&period;类型定义的检查</a>
			</li>
						<li><a href="https://www.batexi.com/a/390erjqd.html">DirectX Graphics Infrastructure&lpar;DXGI&rpar;&colon;最佳范例 学习笔记</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1jj6qg.html">如何使用dos命令查看MySQL当前使用的数据库？</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4nr39z.html">Configure a bridged network interface for KVM using RHEL 5&period;4 or later&quest;</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvrex8x.html">OpenGL shader 中关于顶点坐标值的思考</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8og0eqz.html">&lbrack;转&rsqb;ThinkPHP中实例化对象M&lpar;&rpar;和D&lpar;&rpar;的区别，select和find的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4dj5qz.html">我的MYSQL学习心得（二） 数据类型宽度</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxy5z9y.html">Android（1）&mdash;Mono For Android 环境搭建及破解</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
